/*-
 * Copyright (c) 1994 The Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by the University of
 *      California, Berkeley and the Network Research Group at
 *      Lawrence Berkeley Laboratory.
 * 4. Neither the name of the University nor of the Laboratory may be used
 *    to endorse or promote products derived from this software without
 *    specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * @(#) /home/mmlab1/Software/CVSMaster/vic/encoder-h261.h,v 1.2 1995/08/16 00:45:34 olson Exp (LBL)
 */

#ifndef vic_encoder_h261_h
#define vic_encoder_h261_h

#include <sys/types.h>
#include <netinet/in.h>
#include "inet.h"
#include "framer.h"

class H261Encoder : public YuvEncoder {
 public:
	H261Encoder(Network*, int mtu);
	~H261Encoder();
	virtual void size(int w, int h);
	int encode(n_long ts, const u_char* frame, u_char* crvec);
 protected:
	int command(Tcl& t, int argc, char** argv);
	void encode_frm(const u_char* frame, u_char* crvec);
	void encode_mb(int mba, const u_char* frm, int loff, int coff);
	void encode_blk(short* blk);
	void saveblk(const u_char* yp, u_char* cache, int stride) const;
	void grow();

	/* bit buffer */
	u_int bb_;
	u_int nbb_;

	u_char* buffer_;
	u_char* bs_;
	u_char* es_;

	int quant_;
	int mquant_;
	int ngob_;
	int mba_;

	int cif_;		/* 1 for CIF, 0 for QCIF */
	int bstride_;
	int lstride_;
	int cstride_;

	void setq(int q);
	int qt_[64];
	int qinv_[64];

	int coff_[12];
	int loff_[12];
	int blkno_[12];

	struct offset {
		int off;
		int bit;
	} offset_[12];
};

#endif

