#
# Copyright (c) 1993 Regents of the University of California.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. All advertising materials mentioning features or use of this software
#    must display the following acknowledgement:
#	This product includes software developed by the Computer Systems
#	Engineering Group at Lawrence Berkeley Laboratory.
# 4. Neither the name of the University nor of the Laboratory may be used
#    to endorse or promote products derived from this software without
#    specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# @(#) /home/mmlab1/Software/CVSMaster/vic/vic.tcl,v 1.5 1995/08/25 17:39:00 olson Exp (LBL)
#
# NOTE: This file is provided for reference purposes.  The code
#       shown here is compiled into vic.  DON'T use this as your
#	vic startup file (~/.vic.tcl).
#

proc yesno { attr } {
	set v [option get . $attr Vic]
	if { [string match \[0-9\]* $v] } {
		return $v
	}
	if { $v == "true" || $v == "True" || $v == "t" } {
		return 1
	} elseif { $v == "false" || $v == "False" || $v == "f" } {
		return 0
	}
	return 0
}

#
# We want these resources to override user defaults
# (the option command's "userDefault" priority is 60)
# We do this for a consistent user inteface "look".
# Too often, people define *background and *foreground
# in their X resources, which gives bad results with tk.
#
option add *background gray80 61
option add *foreground black 61
option add *activeBackground gray95 61
option add *selectBackground gray95 61
option add *Scale.sliderForeground gray66 61
option add *Scale.activeForeground gray80 61
#option add *Scale.background gray70 61
option add *Scrollbar.foreground gray80 61
option add *Scrollbar.activeForeground gray70 61
option add *disabledForeground gray40

option add *Radiobutton.relief flat startupFile

#
# These can be overridden.
#
option add Vic.mtu 1024 startupFile
option add Vic.defaultRate 2 startupFile
option add Vic.defaultTTL 16 startupFile
option add Vic.maxbw -1 startupFile
option add Vic.bandwidth 128 startupFile
option add Vic.iconPrefix vic: startupFile
option add Vic.priority 10 startupFile

option add Vic.defaultFormat none startupFile
option add Vic.grabber none startupFile
option add Vic.stampInterval 1000 startupFile
option add Vic.switchInterval 5 startupFile
option add Vic.colorModel best startupFile
option add Vic.tile 1 startupFile
option add Vic.filterGain 0.25 startupFile
option add Vic.statsFilter 0.0625 startupFile

#
# color resources
#
option add Vic.medianCutColors 150 startupFile
option add Vic.ditherGrays true startupFile
option add Vic.gamma 0.7 startupFile

#
# RTIP defaults
#
option add Vic.rtipXmin 655 startupFile
option add Vic.rtipXave 655 startupFile
option add Vic.rtipI 6553 startupFile
option add Vic.rtipSmax 1200 startupFile
option add Vic.rtipD 1200 startupFile
option add Vic.rtipJ 3279 startupFile
option add Vic.rtipZ 10000 startupFile
option add Vic.rtipW 1000 startupFile
option add Vic.rtipU 1000 startupFile
option add Vic.rtipType 1 startupFile

option add Vic.foundry adobe startupFile

#XXX not fully tested
proc mapf { f } {
	if { ! [havefont $f] } {
		set i [string first 75 $f]
		set f [string range $f 0 [expr $i - 1]]*-*-*-*-*-*
	}
	return $f
}
set ff [option get . foundry Vic]
set helv10 [mapf "-$ff-helvetica-medium-r-normal--*-100-75-75-*-*-*-*"]
set helv10b [mapf "-$ff-helvetica-bold-r-normal--*-100-75-75-*-*-*-*"]
set helv10o [mapf "-$ff-helvetica-bold-o-normal--*-100-75-75-*-*-*-*"]
set helv12 [mapf "-$ff-helvetica-medium-r-normal--*-120-75-75-*-*-*-*"]
set helv12b [mapf "-$ff-helvetica-bold-r-normal--*-120-75-75-*-*-*-*"]
set helv14 [mapf "-$ff-helvetica-medium-r-normal--*-140-75-75-*-*-*-*"]
set helv14b [mapf "-$ff-helvetica-bold-r-normal--*-140-75-75-*-*-*-*"]
set times14 [mapf  "-$ff-times-medium-r-normal--*-140-75-75-*-*-*-*"]

option add *Font $helv12b startupFile
option add Vic.disablefont $helv10o
option add Vic.smallfont $helv10b
option add Vic.medfont $helv12b  startupFile
option add Vic.helpFont $times14 startupFile
option add Vic.entryFont $helv10 startupFile
option add Vic.suppressUserName true startupFile
#XXX
option add Vic.softJPEGthresh -1 startupFile
option add Vic.softJPEGcthresh 6 startupFile

set defaultMuteState 0

set last_src 0

proc smallfont { } {
	return [option get . smallfont Vic]
}

proc mediumfont { } {
	return [option get . medfont Vic]
}

proc disfont { } {
	return [option get . disablefont Vic]
}

#XXX allow all/or non-senders to be shown
proc build.srclist { } {
	set w .srclist
	toplevel $w
	wm withdraw $w
	wm geometry $w 300x320
#	bind $w <Enter> "focus $w"
	#XXX
	wm title $w "VIC Members"
	wm minsize $w 0 0
	global srclist
	frame $w.b -borderwidth 2 -relief sunken
	scrollbar $w.b.scroll -relief groove -borderwidth 2 \
			-command "$w.b.list yview"
	#
	# Note that we make the canvas dimensions small so that
	# if the user resizes the window, the dismiss button
	# doesn't disappear.  The default size is set by the
	# wm geometry command above.
	#
	canvas $w.b.list -relief groove -borderwidth 0 \
		-yscrollcommand "$w.b.scroll set" -height 10 -width 10
	set srclist $w.b.list

	button $w.ok -text " Dismiss " -borderwidth 0 -relief raised \
		-command "wm withdraw $w" -font [mediumfont] 

	pack $w.b -fill both -expand 1
	pack $w.b.scroll -side left -fill y
	pack $w.b.list -side left -expand 1 -fill both
	pack $w.ok -fill x
}
	
proc toggle_window { w } {
	if { ![winfo exists $w] } { build$w }
	global created$w
	if { ! [info exists created$w] } {
		set created$w 1
		wm transient $w .
		update idletasks
		set x [winfo rootx .]
		set y [winfo rooty .]
		incr y [winfo height .]
		incr y -[winfo reqheight $w]
		incr y -20
 		# adjust for virtual desktops
		incr x [winfo vrootx .]
		incr y [winfo vrooty .]
		if { $y < 0 } { set y 0 }
		if { $x < 0 } {
			set x 0
		} else {
			set right [expr [winfo screenwidth .] - \
					[winfo reqwidth $w]]
			if { $x > $right } {
				set x $right
			}
		}
		wm geometry $w +$x+$y
		wm deiconify $w
	} elseif { [winfo ismapped $w] } {
		wm withdraw $w
	} else {
		wm deiconify $w
	}
}

proc start_mediancut { } {
	global heckbert_button
	$heckbert_button configure -state disabled
	srctab mediancut
}

proc finish_mediancut { } {
	global heckbert_button
	$heckbert_button configure -state normal
	srctab redraw
}

#
# Build the menu panel.  Called from toggle_window,
# the first time the Menu button is hit.
#
proc build.menu { } {
	set w .menu
	toplevel $w
	wm title $w "vic menu"
	wm withdraw $w
#	bind $w <Enter> "focus $w"

	frame $w.session
	frame $w.cb
	build.xmit $w.cb
	frame $w.encoder
	build.encoder $w.encoder
	build.session $w.session [session addr] [session port] \
		[session srcid] [session ttl] [session name]

	frame $w.bot
	button $w.bot.ok -text Dismiss -borderwidth 2 -width 8 \
		-relief raised -anchor c \
		-command "toggle_window $w" -font [mediumfont]
	button $w.bot.part -text Members -borderwidth 2 -width 8 \
		-relief raised -anchor c \
		-command "toggle_window .srclist" -font [mediumfont]
	button $w.bot.heckbert -text Colors -borderwidth 2 -width 8 \
		-relief raised -anchor c \
		-command start_mediancut -font [mediumfont]
	global heckbert_button
	set heckbert_button $w.bot.heckbert

	set m $w.bot.col.menu
	menubutton $w.bot.col -text Tile... -menu $m -relief raised -width 8

	set f [smallfont]
	menu $m
	$m add radiobutton -label Single -command "redecorate 1" \
		-value 1 -variable ncol -font $f
	$m add radiobutton -label Double -command "redecorate 2" \
		-value 2 -variable ncol -font $f
	$m add radiobutton -label Triple -command "redecorate 3" \
		-value 3 -variable ncol -font $f
	$m add radiobutton -label Quad -command "redecorate 4" \
		-value 4 -variable ncol -font $f

	frame $w.bot.gap

	pack $w.cb $w.encoder $w.session -padx 6 -fill x
	pack $w.bot -anchor c
	pack $w.bot.col -side left -anchor c -padx 4 -pady 8
	pack $w.bot.part -side left -anchor c -padx 4 -pady 4
	pack $w.bot.heckbert -side left -anchor c -padx 4 -pady 4
	pack $w.bot.ok -side right -anchor c -padx 4 -pady 8

	global initialDeviceButton
	$initialDeviceButton invoke
}

proc build.table { w } {
	global table
	set table $w.table
	frame $table
	blt_table $table
	blt_table column $table configure all -resize none
	blt_table row $table configure all -resize none
}
	
proc build.bar { w } {
	global title
	frame $w.bar
	label $w.bar.title -text "VIC v[version]" -font [smallfont]\
		-background gray -borderwidth 2 -relief raised
	button $w.bar.quit -text Quit -borderwidth 2 -relief raised \
		-background gray -font [smallfont] -command adios
	button $w.bar.menu -text Menu -borderwidth 2 -relief raised \
		-background gray -font [smallfont] \
		-command "toggle_window .menu"
	button $w.bar.help -text Help -borderwidth 2 -relief raised \
		-background gray -font [smallfont] \
		-command "toggle_window .help"

	pack $w.bar.title -side left -fill x -expand 1
	pack $w.bar.menu $w.bar.help $w.bar.quit -side left
}

#
# Build the user-interface.
#
proc build.tk { } {
	set conf [option get . conferenceName Vic]
	global prefix
	set prefix [option get . iconPrefix Vic]
	wm iconname . $prefix$conf
	wm title . $conf

	. configure -background [option get . background Vic]
	#
	# emulate implicit keyboard focus
	#
#	bind . <Enter> { focus %W }
	#wm focusmodel . active
	bind . <q> { adios }
	bind . <Control-c> { adios }
	bind . <Control-d> { adios }

	foreach i { 1 2 3 4 } {
		bind . <Key-$i> "redecorate $i"
	}

	frame .top
	build.bar .top
	pack .top.bar -fill x -side bottom
	pack .top -expand 1 -fill both

        label .top.label -text "No Network Sources"
	pack .top.label -before .top.bar -anchor c -expand 1

	#
	# Withdraw window so that user-placement is deferred
	# until after initial geometry is computed
	#
	wm withdraw .
	wm geometry . 300x225
	update idletasks
	set minwidth [winfo reqwidth .]
	set minheight [winfo reqheight .]
	#XXX
	if { $minwidth < 200 || $minheight < 100 } {
		set minwidth 200
		set minheight 100
	}
	wm minsize . $minwidth $minheight
	wm deiconify .
	build.srclist
}

proc add_active { src } {
	global active
	set active($src) 1
	if { [array size active] == 1 } {
		pack forget .top.label
		build.table .top
		pack .top.table -fill both -anchor n
	}
}

proc rm_active { src } {
	global active table
	unset active($src)
	if { [array size active] == 0 } {
		pack forget $table
		destroy $table
		pack .top.label -before .top.bar -anchor c -expand 1
	}
}

proc mk.entry { w action text } {
	entry $w.entry -relief raised -borderwidth 1 -exportselection 1 \
		-font [option get . entryFont Vic]
	global entryTab
	set entryTab($w.entry:action) $action
	set entryTab($w.entry:value) $text
	$w.entry insert 0 $text
}

proc setcrypt { w key } {
	global sessionKey doEncryption entryTab
	if { ![net crypt $key] || $key == "" } {
		# illegal encryption string, clear it out
		# and disable encryption
		set sessionKey ""
	        set entryTab($w.entry:value) ""
		$w.button configure -state disabled
		set doEncryption 0
		return -1
	} else {
		set sessionKey $key
		$w.button configure -state normal
		set doEncryption 1
		return 0
	}
}

proc toggleKey { w } {
        global sessionKey doEncryption
	if $doEncryption {
		setcrypt $w $sessionKey
	} else {
		net crypt ""
	}
}

proc updateKey { w key } {
	return [setcrypt [winfo parent $w] [string trim $key]]
}

proc mk.key { w } {
	global sessionKey
	set sessionKey [option get . sessionKey Vic]
	frame $w.key
	checkbutton $w.key.button -text Key: -relief flat -font [smallfont] \
		-command "toggleKey $w.key" -variable doEncryption \
		-disabledforeground gray40
	mk.entry $w.key updateKey ""

	global doEncryption
	if { $sessionKey == "" } {
		set doEncryption 0
		$w.key.button configure -state disabled
	} else {
		set doEncryption 1
	}
	pack $w.key.button -side left
	pack $w.key.entry -side left -fill x -expand 1
}

proc build.session { w dst port srcid ttl name } {
	set f [smallfont]	

	label $w.title -text Session
	pack $w.title -fill x

	frame $w.nb -relief sunken -borderwidth 2
	pack $w.nb -fill x

	frame $w.nb.frame
	pack append $w.nb \
		$w.nb.frame { top fillx }

	label $w.nb.frame.info -font $f -anchor w \
		-text "Dest: $dst   Port: $port  ID: $srcid  TTL: $ttl"

	frame $w.nb.frame.name
	label $w.nb.frame.name.label -text "Name: " -font $f -anchor e -width 6
	mk.entry $w.nb.frame.name updateName $name
	pack $w.nb.frame.name.label -side left
	pack $w.nb.frame.name.entry -side left -expand 1 -fill x -pady 2

	mk.key $w.nb.frame

	frame $w.nb.frame.b
	global defaultMuteState
	checkbutton $w.nb.frame.b.mnb -text "Mute New Sources" -borderwidth 2 \
		-relief flat -anchor c -variable defaultMuteState -font $f 

	global sendingSlides
	checkbutton $w.nb.frame.b.frb -text "Sending Slides" -borderwidth 2 \
		-relief flat -anchor c -variable sendingSlides -font $f \
		-command setFillRate
	pack $w.nb.frame.b.mnb $w.nb.frame.b.frb -side left -expand 1 -fill x

	pack $w.nb.frame.info $w.nb.frame.name $w.nb.frame.key $w.nb.frame.b \
		-fill x -padx 2
}

proc setFillRate { } {
	global sendingSlides transmitButtonState
	if { $transmitButtonState } {
		if { $sendingSlides } {
			device fillrate 16
		} else {
			device fillrate 2
		}
	}
}

proc updateName { w name } {
	set name [string trim $name]
	if { $name != ""} {
		session name $name
		return 0
	}
	return -1
}

proc set_rate_vars { src } {
	global fpshat bpshat lhat shat
	if [info exists fpshat($src)] {
		unset fpshat($src)
		unset bpshat($src)
		unset lhat($src)
		unset shat($src)
	}
	set gain [option get . filterGain Vic]
	set fpshat($src) 0
	rate_variable fpshat($src) $gain
	set bpshat($src) 0
	rate_variable bpshat($src) $gain
	set lhat($src) 0
	rate_variable lhat($src) $gain
	set shat($src) 0
	rate_variable shat($src) $gain

#XXX set guys in stat window too!
}
	
set transmitButtonState 0
set_rate_vars encoder

proc transmit { } {
	global transmitButtonState videoFormat videoDevice
	if ![device open] {
		set err [device open $videoDevice $videoFormat]
		if { $err == -2 } {
			#XXX hack: this happens when we tried to open
			# a jvideo with a non-jpeg format
			set transmitButtonState 0
			vic_dialog .grabberError \
				"Can't use jvideo with $videoFormat format"
			select_device $videoDevice
			return
		} elseif { $err < 0 } {
			# XXX this is kind of gross
			set transmitButtonState 0
			vic_dialog .grabberError \
				"vic: can't open capture device"
			return
		}
		init_device
	}
#puts "send $transmitButtonState"
	device send $transmitButtonState
}

proc release_device { } {
	global transmitButtonState transmitButton
	if [device open] {
		if $transmitButtonState {
			$transmitButton invoke
		}
		device close
	}
}

proc build.buttons { w } {
	set f [smallfont]
	global transmitButton
	set transmitButton $w.send
	checkbutton $w.send -text "Transmit" -borderwidth 2 \
		-relief raised -command transmit \
		-anchor w -variable transmitButtonState -font $f \
		-state disabled
	button $w.release -text "Release" -borderwidth 2 \
		-relief raised -command release_device \
		-font $f
	checkbutton $w.lock -text "Lock" -borderwidth 2 -relief raised \
		-command { if [device open] { device lock $lockButton } } \
		-anchor w -variable lockButton -font $f

	pack $w.send $w.lock $w.release -fill x -anchor w -expand 1
}

proc set_bps { w value } {
	if [device open] {
		device bps $value
	}
	$w configure -text "$value kbps"
}

proc set_fps { w value } {
	if [device open] {
		device fps $value
	}
	$w configure -text "$value fps"
}

proc build.sliders { w } {
	set f [smallfont]

	global ftext btext
	set ftext(encoder) "0.0 f/s"
	set btext(encoder) "0.0 kb/s"

	frame $w.info
	label $w.info.label -text "Rate Control" -font $f
	label $w.info.fps -textvariable ftext(encoder) -width 6 \
		-font $f -pady 0 -borderwidth 0
        label $w.info.bps -textvariable btext(encoder) -width 8 \
		-font $f -pady 0 -borderwidth 0
	pack $w.info.label -side left
	pack $w.info.bps $w.info.fps -side right
	
	frame $w.bps
	scale $w.bps.scale -orient horizontal -font $f \
		-showvalue 0 -from 10 -to [option get . maxbw Vic] \
		-command "set_bps $w.bps.value" -width 12 \
		-relief groove
	label $w.bps.value -font $f -width 8 -anchor w

	frame $w.fps
	scale $w.fps.scale -font $f -orient horizontal \
		-showvalue 0 -from 1 -to 30 \
		-command "set_fps $w.fps.value" -width 12 \
		-relief groove
	label $w.fps.value -font $f -width 8 -anchor w

	pack $w.info -fill x
	pack $w.bps $w.fps -fill x
	pack $w.bps.scale -side left -fill x -expand 1
	pack $w.bps.value -side left -anchor w 
	pack $w.fps.scale -fill x -side left -expand 1
	pack $w.fps.value -side left -anchor w
	
	$w.bps.scale set [option get . bandwidth Vic]
	$w.fps.scale set [option get . defaultRate Vic]

	global fps_slider bps_slider
	set fps_slider $w.fps.scale
	set bps_slider $w.bps.scale
}

#
# Called when use selects a particular device (like videopix or xil)
# (and at startup for default device)
#
proc select_device { devname } {
	global transmitButton sizeButtons portButton typeButton formatButtons

	foreach b $formatButtons {
		set fmt [lindex [$b configure -value] 4]
		if [device format $devname $fmt] {
			$b configure -state normal
		} else {
			$b configure -state disabled
		}
	}
	$transmitButton configure -state normal
	if [device supports $devname small] {
		$sizeButtons.b0 configure -state normal
	} else {
		$sizeButtons.b0 configure -state disabled
	}
	if [device supports $devname large] {
		$sizeButtons.b2 configure -state normal
	} else {
		$sizeButtons.b2 configure -state disabled
	}
	if [device supports $devname port] {
		$portButton configure -state normal
	} else {
		$portButton configure -state disabled
	}
	if [device supports $devname type] {
		$typeButton configure -state normal
	} else {
		$typeButton configure -state disabled
	}
	#XXX should remember last chosen 
	select_default_format [device default $devname]
}

proc build.device { w } {
#XXX check for no devices
	set f [smallfont]
	frame $w.glue0
	pack $w.glue0 -fill y -expand 1
	set devnum 0
	foreach d [device list] {
		# this is fragile
		set p $w.b$devnum
		radiobutton $p -text $d -relief flat -font $f \
			-command "select_device $d" \
			-variable videoDevice -value $d -anchor w
		pack $p -fill x
		incr devnum
	}
	frame $w.glue1
	pack $w.glue1 -fill y -expand 1

	#XXX
	global initialDeviceButton
	set initialDeviceButton $w.b0
}

proc format_col { w n0 n1 n2 } {
	set f [smallfont]
	frame $w
	radiobutton $w.b0 -text $n0 -relief flat -font $f -anchor w \
		-variable videoFormat -value $n0 \
		-command "select_format $n0"
	radiobutton $w.b1 -text $n1 -relief flat -font $f -anchor w \
		-variable videoFormat -value $n1 \
		-command "select_format $n1"
	radiobutton $w.b2 -text $n2 -relief flat -font $f -anchor w \
		-variable videoFormat -value $n2 \
		-command "select_format $n2"
	pack $w.b0 $w.b1 $w.b2 -fill x 

	global formatButtons
	lappend formatButtons $w.b0 $w.b1 $w.b2
}

proc build.format { w } {
	format_col $w.p0 nv cellb scr
	format_col $w.p1 jpeg h261 mpeg

	frame $w.glue0
	frame $w.glue1

	pack $w.glue0 -side left -fill x -expand 1
	pack $w.p0 $w.p1 -side left
	pack $w.glue1 -side left -fill x -expand 1
}

proc build.size { w } {
	set f [smallfont]
	frame $w -relief sunken -borderwidth 2
	radiobutton $w.b0 -text "small" -command "device ctrl decimate 4" \
		-anchor w -variable inputSize -font $f -relief flat -value 4
	radiobutton $w.b1 -text "normal" -command "device ctrl decimate 2" \
		-anchor w -variable inputSize -font $f -relief flat -value 2
	radiobutton $w.b2 -text "large" -command "device ctrl decimate 1" \
		-anchor w -variable inputSize -font $f -relief flat -value 1
	pack $w.b0 $w.b1 $w.b2 -fill x
	global inputSize sizeButtons
	set inputSize 2
	set sizeButtons $w
}

proc build.port { w } {
	set f [smallfont]

	set m $w.menu
	menubutton $w -text Port... -menu $m -relief raised -width 7 -font $f
	menu $m
	$m add radiobutton -label "Port 1" -command "device ctrl port 1" \
		-value 1 -variable inputPort -font $f
	$m add radiobutton -label "Port 2" -command "device ctrl port 2" \
		-value 2 -variable inputPort -font $f
	$m add radiobutton -label "S-Video" -command "device ctrl port 3" \
		-value 3 -variable inputPort -font $f

	global inputPort portButton
	set inputPort 1
	set portButton $w
}

proc build.type { w } {
	set f [smallfont]

	set m $w.menu
	menubutton $w -text Type... -menu $m -relief raised -width 7 -font $f
	menu $m
	$m add radiobutton -label "auto" -command restart \
		-value auto -variable inputType -font $f
	$m add radiobutton -label "NTSC" -command restart \
		-value ntsc -variable inputType -font $f
	$m add radiobutton -label "PAL" -command restart \
		-value pal -variable inputType -font $f
	$m add radiobutton -label "SECAM" -command restart \
		-value secam -variable inputType -font $f

	global inputType typeButton
	set inputType auto
	set typeButton $w
}

proc build.encoder { w } {
	label $w.title -text Encoder
	frame $w.h0
	frame $w.h0.format -relief sunken -borderwidth 2
	frame $w.h0.device -relief sunken -borderwidth 2
	build.format $w.h0.format
	build.size $w.h0.size
	build.device $w.h0.device
	frame $w.h1 -relief sunken -borderwidth 2
	build.port $w.h1.port
	build.type $w.h1.type
	build.q $w.h1.q

	pack $w.h0.format -side left -anchor n -fill both -expand 1
	pack $w.h0.size -side left -anchor n -fill x
	pack $w.h0.device -side left -anchor n -fill y

	pack $w.h1.q -side left -fill x -pady 6
	pack $w.h1.port -side left -anchor n -pady 6
	pack $w.h1.type -side left -anchor n -pady 6 -padx 4

	pack $w.title $w.h0 $w.h1 -fill x
}

proc jpeg_setq { value } {
	incr value
	if { $value > 95 } {
		set value 95
	} elseif { $value < 5 } {
		set value 5
	}
	if [device open] {
		device ctrl q $value
	}
	global qvalue
	$qvalue configure -text $value
}

proc h261_setq { value } {
	set value [expr int((1 - $value / 100.) * 29) + 1]
	if [device open] {
		encoder q $value
	}
	global qvalue
	$qvalue configure -text $value
}

proc nv_setq { value } {
	set value [expr (100 - $value) / 10]
	if [device open] {
		encoder q $value
	}
	global qvalue
	$qvalue configure -text $value
}

proc select_default_format { f } {
	# default format is jpeg
	set fmt [option get . defaultFormat Vic]
	if { $fmt == "" ||  $fmt == "none" } {
		set fmt $f
	}
	if { $fmt == "h.261" } {
		set fmt h261
	}
	global videoFormat
	set videoFormat $fmt
	select_format $fmt
}

#
# If the capture device is open, close it.  If transmission
# was active fire it up again.  Some state can only be set at
# device open time, so some controls must resort to this proc.
#
proc restart { } {
	if [device open] {
		global transmitButtonState
		if $transmitButtonState {
			device send 0
			device close
			transmit
		} else {
			device close
		}
	}
}

proc disable_large_button { } {
	global sizeButtons inputSize
	if { $inputSize == 1 } {
		set inputSize 2
	}
	$sizeButtons.b2 configure -state disabled
}

proc enable_large_button { } {
	global sizeButtons videoDevice
	if [device supports $videoDevice large] {
		$sizeButtons.b2 configure -state normal
	}
}

set qscale_val(h261) 68
set qscale_val(nv) 80
set qscale_val(jpeg) 29
set lastFmt ""

proc select_format { fmt } {
	global qscale qlabel videoFormat qscale_val lastFmt

	enable_large_button
	set qscale_val($lastFmt) [$qscale get]
	set lastFmt $videoFormat
	switch $fmt {
		nv {
			$qscale configure -state normal -command nv_setq
			$qlabel configure -foreground black
			$qscale set $qscale_val(nv)
		}
		jpeg {
			$qscale configure -state normal -command jpeg_setq
			$qlabel configure -foreground black
			$qscale set $qscale_val(jpeg)
		}
		h261 {
			$qscale configure -state normal -command h261_setq
			$qlabel configure -foreground black
			$qscale set $qscale_val(h261)
			# H.261 supports only QCIF/CIF
			disable_large_button
		}
		default {
			$qscale configure -state disabled 
			$qlabel configure -foreground gray40
			if [info exists qscale_val($fmt)] {
				$qscale set $qscale_val($fmt)
			}
		}
	}
	restart
}

proc init_device { } {
	global qscale inputSize fps_slider bps_slider lockButton
	device fps [$fps_slider get]
	device bps [$bps_slider get]
	device ctrl decimate $inputSize
	device lock $lockButton
	if { [lindex [$qscale configure -state] 4] == "normal" } {
		set cmd [lindex [$qscale configure -command] 4]
		$cmd [$qscale get]
	}

	global inputPort inputType
	device ctrl port $inputPort
	device ctrl type $inputType
	setFillRate
#	if { $inputType != "auto" } {
#		set inputType [device ctrl format]
#	}
}

proc build.q { w } {
	set f [smallfont]
	frame $w
	frame $w.tb
	label $w.title -text "Quality" -font $f -anchor w
	label $w.tb.value -text 0 -font $f -width 3
	scale $w.tb.scale -font $f -orient horizontal \
		-showvalue 0 -from 0 -to 99 \
		-width 12 -relief groove
	global qscale qvalue qlabel
	set qscale $w.tb.scale
	set qvalue $w.tb.value
	set qlabel $w.title

	pack $w.tb.scale -side left -fill x -expand 1
	pack $w.tb.value -side left
	pack $w.title -padx 2 -side left
	pack $w.tb -fill x -padx 6 -side left -expand 1
}

proc build.xmit { w } {
	set f [smallfont]
	label $w.label -text Transmission
	frame $w.frame -relief sunken -borderwidth 2
	pack $w.label -fill x
	pack $w.frame -fill x -expand 1

	frame $w.frame.buttons
	build.buttons $w.frame.buttons
	frame $w.frame.right
	build.sliders $w.frame.right

	pack $w.frame.buttons -side left -padx 6 -pady 4
	pack $w.frame.right -side right -expand 1 -fill x -padx 10 -anchor c
}

set nids 0
proc uniqueID { } {
	global nids
	incr nids
	return $nids
}

proc isCIF { fmt } {
	# only supported CIF format is h.261
	if { $fmt == "h261" } {
		return 1
	}
	return 0
}

#
# destroy a viewing window but remember where it was
# and what size it was
#
proc destroy_userwin { w src } {
	set x [winfo rootx $w]
	set y [winfo rooty $w]
	# adjust for virtual desktops
	incr x [winfo vrootx $w]
	incr y [winfo vrooty $w]
	global userwin_x userwin_y userwin_size size$w
	set userwin_x($src) $x
	set userwin_y($src) $y
	set userwin_size($src) [set size$w]
	destroy $w
}

#
# create a new window for viewing video
# (i.e., a UserWindow as opposed to a VideoWindow in the C++ code)
#
proc instantiate { src } {
	set f [smallfont]	
	set uid [uniqueID]
	set w .vic$uid
	toplevel $w
	frame $w.frame

	global size$w userwin_x userwin_y userwin_size
	if [info exists userwin_x($src)] {
		wm geometry $w +$userwin_x($src)+$userwin_y($src)
		wm positionfrom $w user
		set size$w $userwin_size($src)
		switch $userwin_size($src) {
			QCIF { video $w.frame.video 176 144 }
			CIF { video $w.frame.video 352 288 }
			SCIF { video $w.frame.video 704 576 }
			QNTSC { video $w.frame.video 160 120 }
			NTSC { video $w.frame.video 320 240 }
			SNTSC { video $w.frame.video 640 480 }
			default	{ puts "XXX $userwin_size($src)" }
		}
	} elseif [isCIF [$src format]] {
		video $w.frame.video 352 288
		set size$w CIF
	} else {
		video $w.frame.video 320 240
		set size$w NTSC
	}
	set v $w.frame.video
	frame $w.bar
	button $w.bar.dismiss -text Dismiss -font $f -width 8

	set m $w.bar.mode.menu
	menubutton $w.bar.mode -text Mode... -menu $m -relief raised -width 8 \
		-font $f
	menu $m

	#
	# Use the window "name" as the variable for its mode
	#
	set mode [winfo name $w]
	global $mode
	set $mode locked
	$m add radiobutton -label Locked -command "$v locked" \
		-font $f -value locked -variable $mode
	$m add radiobutton -label Voice-switched -command "$v voice" \
		-font $f -value switched -variable $mode
	$m add radiobutton -label Browse -command "$v browse " \
		-font $f -value browse -variable $mode
	$m add separator
	$m add checkbutton -label "External" \
		-command "$v outboard \$outboard$uid" \
		-font $f -variable outboard$uid

	set m $w.bar.size.menu
	menubutton $w.bar.size -text Size... -menu $m -relief raised -width 8 \
		-font $f
	menu $m
	$m add radiobutton -label QCIF -command "$v resize 176 144" \
		-font $f -value QCIF -variable size$w
	$m add radiobutton -label CIF -command "$v resize 352 288" \
		-font $f -value CIF -variable size$w
	$m add radiobutton -label SCIF -command "$v resize 704 576" \
		-font $f -value SCIF -variable size$w

	$m add separator
	$m add radiobutton -label "1/16 NTSC" -command "$v resize 160 120" \
		-font $f -value QNTSC -variable size$w
	$m add radiobutton -label "1/4 NTSC" -command "$v resize 320 240" \
		-font $f -value NTSC -variable size$w
	$m add radiobutton -label NTSC -command "$v resize 640 480" \
		-font $f -value SNTSC -variable size$w

	#
	# initialize text to "this is a bug" since it
	# should be set externally before it is ever displayed
	#
	label $w.bar.label -text "" -anchor w -relief raised
	pack $w.bar.label -expand 1 -side left -fill both
	pack $w.bar.size $w.bar.mode $w.bar.dismiss -side left -fill y

	pack $w.frame.video -anchor c
	pack $w.frame -expand 1 -fill both
	pack $w.bar -fill x

#	bind $w <Enter> { focus %W }
	#wm focusmodel $w active

	bind $w <d> "destroy_userwin $w $src"
	bind $w <q> "destroy_userwin $w $src"
	$w.bar.dismiss configure -command "destroy_userwin $w $src"

	bind $w <Return> "$v key Return"
	bind $w <space> "$v key space"
	bind $w <greater> "$v key greater"
	bind $w <less> "$v key less"
	bind $w <plus> "$v key plus"
	bind $w <equal> "$v key equal"
	bind $w <minus> "$v key minus"
	bind $w <underscore> "$v key underscore"

	#
	# Return the name of the window so our C++ code
	# can map it back to a VideoWindow object.
	#
	return $v
}

proc windowname { w name } {
	if ![yesno suppressUserName] {
		$w.bar.label configure -text $name
	}
	wm iconname $w vic:$name
	wm title $w $name
}

proc change_name { src } {
	set name [$src name]
	global nametag srclist
	if [info exists srclist] {
		$srclist itemconfigure $nametag($src) -text $name
	}
	update_source_info $src
}

set srclist_bottom 2
#
# Register a src in the src display.  This happens for all the
# srcs participating in the conferencing (e.g., including
# those not actually sending video).
#
proc register { src } {
	global srcstate srclist srclist_bottom nametag
	set srcstate($src) 1
	if [info exists srclist] {
		set f [mediumfont]
		set nametag($src) [ $srclist create text \
			5 $srclist_bottom -font $f -text [$src addr] \
				-anchor nw ]
		set srclist_bottom \
			[ lindex [ $srclist bbox $nametag($src) ] 3 ]
		incr srclist_bottom 2
		$srclist config -scrollregion "0 0 2.5i $srclist_bottom"
	}
}

proc adjustNames { thresh h } {
	global nametag srclist srclist_bottom
	foreach s [array names nametag] {
		set y [lindex [$srclist coords $nametag($s)] 1]
		if { $y > $thresh } {
			$srclist move $nametag($s) 0 -$h
		}
	}
	incr srclist_bottom -$h
	$srclist config -scrollregion "0 0 2.5i $srclist_bottom"
}

#
# Remove a src from the src display.  This happens when
# a party quits or has been dead for a sufficiently long time.
# We assume the src has already been deactivated.
#
proc unregister { src } {
	global name_line info_line nametag srclist
	#
	# Delete name_line and info_line if they exist.
	# They might not be created until the first NAME
	# report (and they aren't used until a source is activated).
	#
	if [info exists name_line($src)] {
		unset name_line($src)
		unset info_line($src)
	}
	set thresh [lindex [$srclist coords $nametag($src)] 1]
	set bb [$srclist bbox $nametag($src)]
	set height [expr [lindex $bb 3] - [lindex $bb 1]]
	incr height 2
	if [info exists srclist] {
		$srclist delete $nametag($src)
		unset nametag($src)
		adjustNames $thresh $height
	}
}

proc grayout { src } {
	global nametag srclist srcstate
	if [info exists srclist] {
		$srclist itemconfigure $nametag($src) -stipple gray50
	}
	set srcstate($src) 2
}

proc embolden { src } {
	global nametag srclist
	if [info exists srclist] {
		$srclist itemconfigure $nametag($src) -stipple {}
	}
	set srcstate($src) 1
}

#
# Called when use clicks on thumbnail video window.
# Create a new window only if the window already
# isn't being displayed (in locked mode).  In this
# case, delete the existing window (i.e., clicking
# on the thumbnail gives a toggle action, but not
# for voice-switched or browse-mode windows).
#
proc select_thumbnail { w src } {
	set srcid [$src srcid]
	foreach w [winfo children .] {
		# this is fragile
		set vw $w.frame.video
		if { [winfo exists $vw] && $srcid == [[$vw source] srcid] } {
			set mode [winfo name $w]
			global $mode
			eval set m $$mode
			if { $m == "locked" } {
				destroy $w
				return
			}
		}
	}
	$src select
}

#
# Return true if the two strings provide more or less the
# same informational content
#
proc cname_redundant { name cname } {
	set ni [string first @ $name]
	if { $ni < 0 } {
		return 0
	}
	set ci [string first @ $cname]
	if { $ci < 0 } {
		return 0
	}
	if { [string compare \
		[string range $name 0 $ni] \
		[string range $cname 0 $ci]] == 0 } {
		return 1
	}
	return 0
}

proc update_source_info { src } {
	global info_line name_line
	#
	# Figure out best presentation from available information.
	#
	set name [$src name]
	set cname [$src cname]
	set addr [$src addr]
	if { $name == "" } {
		if { $cname == "" } {
			set name_line($src) $addr
			set info_line($src) $addr/[$src format]

		} else {
			set name_line($src) $cname
			set info_line($src) "$addr/[$src format]"
		}
	} elseif [cname_redundant $name $cname] {
		set name_line($src) $name
		set info_line($src) $addr/[$src format]
	} else {
		set name_line($src) $name
		set info_line($src) $cname/[$src format]
	}
}

proc set_analog { src } {
    global last_src
    global analogbutton
    if { $last_src == 0 } {
#	puts "set_analog got src $src last $last_src"
	$src analog
	set last_src $src
    } elseif { $last_src != $src } {
#	puts "set_analog got src $src last $last_src"
	$last_src analog
	$src analog
	set last_src $src
    } else {
#	puts "unset"
	$src analog
	set last_src 0
	set analogbutton 0
    }
}

proc analog_open_failed { } {
    global last_src
    global analogbutton
    puts "analog open failed but=$analogbutton"
    set last_src 0
    set analogbutton 0
}

proc build.src { w src color } {
	set f [smallfont]
	set stamp $w.stamp
	frame $stamp -relief groove -borderwidth 2
	video $stamp.video 80 60
	pack $stamp.video -side left -anchor c -padx 2
	pack $stamp -side left -fill y
	
	frame $w.r
	frame $w.r.cw -relief groove -borderwidth 2

	pack $w.r.cw -side left -expand 1 -fill both -anchor w -padx 0

	label $w.r.cw.name -textvariable name_line($src) -font $f \
		-pady 1 -borderwidth 0 -anchor w
	label $w.r.cw.addr -textvariable info_line($src) -font $f \
		-pady 1 -borderwidth 0 -anchor w

	global ftext btext ltext
	set ftext($src) "0.0 f/s"
	set btext($src) "0.0 kb/s"
	set ltext($src) "(0%)"
	frame $w.r.cw.rateinfo
	label $w.r.cw.rateinfo.fps -textvariable ftext($src) -width 6 \
		-font $f -pady 0 -borderwidth 0
	label $w.r.cw.rateinfo.bps -textvariable btext($src) -width 8 \
		-font $f -pady 0 -borderwidth 0
	label $w.r.cw.rateinfo.loss -textvariable ltext($src) -width 6 \
		-font $f -pady 0 -borderwidth 0


	frame $w.r.ctrl -borderwidth 0

	global mutebutton defaultMuteState
	set mutebutton($src) $defaultMuteState
	$src disable $defaultMuteState
	checkbutton $w.r.ctrl.mute -text mute -borderwidth 2 \
		-relief groove -font $f -width 4 \
		-command "$src disable \$mutebutton($src)" \
		-variable mutebutton($src)

	checkbutton $w.r.ctrl.color -text color -borderwidth 2 \
		-relief groove -font $f -width 4 \
		-command "$src color \$colorbutton($src)" \
		-variable colorbutton($src)
#
# XXX comment this stuff out until we find more interesting options
#
#	set m $w.r.ctrl.options.menu
#	menubutton $w.r.ctrl.options -text Options... \
#    		-menu $m -relief groove -font $f -borderwidth 2 -width 6
#	menu $m
#	$m add command -label Open -font $f \
#		-command "select_thumbnail $w $src"
#	$m add command -label Delete -font $f \
#		-command "$src delete"
#	$m add separator
#	$m add checkbutton -label mute -font $f \
#		-command "$src disable \$mutebutton($src)" \
#		-variable mutebutton($src)
#	$m add checkbutton -label color -font $f \
#		-command "$src color \$colorbutton($src)" \
#		-variable colorbutton($src)

	button $w.r.ctrl.stats -text stats -borderwidth 2 \
		-relief groove -font $f -width 5 -command "src_summary $src"
	bind $w.r.ctrl.stats <ButtonRelease-1> {
		global mouse_x mouse_y
		set mouse_x %x
		set mouse_y %y
		tk_butUp %W
	}
	radiobutton $w.r.ctrl.analog -text analog -borderwidth 2 \
		-relief groove -font $f -width 4 \
		-command "set_analog $src" \
		-variable analogbutton -value $src

	pack $w.r.ctrl.mute -side left -fill x -expand 1
	pack $w.r.ctrl.color -side left -fill x -expand 1
	pack $w.r.ctrl.stats -side left -fill x -expand 1
	pack $w.r.ctrl.analog -side left -fill x -expand 1
#	pack $w.r.ctrl.options -side left -fill x -expand 1

	global colorbutton
	set colorbutton($src) 1

	pack $w.r.cw.rateinfo.fps $w.r.cw.rateinfo.bps $w.r.cw.rateinfo.loss \
		-side left -anchor w
	pack $w.r.cw.name $w.r.cw.addr $w.r.cw.rateinfo -anchor w -fill x

	pack $w.r.cw -fill x -side top
	pack $w.r.ctrl -fill x -side top
	pack $w.r -side left -expand 1 -fill x
	
	bind $stamp.video <1> "select_thumbnail $w $src"
#	bind $stamp.video <Enter> { focus %W }
	bind $stamp.video <d> "$src deactivate"

	return $stamp.video
}

set curcol 0
set currow 0
set ncol [option get . tile Vic]

proc bump { } {
	global curcol currow ncol
	incr curcol
	if { $curcol == $ncol } {
		set curcol 0
		incr currow
	}
}

proc redecorate { n } {
	global ncol curcol currow table active
	set curcol 0
	set currow 0
	set ncol $n

	if ![info exists table] {
		return
	}

	#
	# Have to destroy the master blt window since there is
	# no provision for deleting columns.
	# XXX check if we're only adding
	#
	set list [session active]
	foreach s $list {
		set w .s$s
		blt_table forget $w
	}
	pack forget $table
	destroy $table
	frame $table
	pack $table -fill x -anchor n
	blt_table $table
	blt_table column $table configure all -resize both
	blt_table row $table configure all -resize none

	foreach s $list {
		set w .s$s
		blt_table $table $w $currow,$curcol -anchor n -fill x
		bump
	}
}

#
# Add a src to the active senders list.  E.g., make a postage
# stamp window appear, stats, etc. so that the user can select
# the video stream.
#
proc activate { src format color } {
	add_active $src

	global table curcol currow
	set w $table
	frame .$src -relief groove -borderwidth 0
	set videowindow [build.src .$src $src $color]
	blt_table $w .$src $currow,$curcol -anchor n -fill x
	blt_table column $w configure all -resize both
	blt_table row $w configure all -resize none

	change_format $src
	after 1000 "update_src $src"

	bump

	#
	# Return the name of the window so our C++ code
	# can map it back to a VideoWindow object.
	#
	return $videowindow
}

proc change_format { src } {
	set_rate_vars $src
	update_source_info $src
}

#
# Remove a src from the active senders list. 
#
proc deactivate { src } {
	global ftext btext ltext fpshat bpshat lhat shat
	if [winfo exists .$src] {
		destroy .$src
		rm_active $src
	}
	if [winfo exists .summary$src] {
		stat_destroy .summary$src $src
	}
	unset ftext($src)
	unset btext($src)
	unset ltext($src)
	unset fpshat($src)
	unset bpshat($src)
	unset lhat($src)
	unset shat($src)
}

proc update_rate { src } {
	global ftext btext ltext fpshat bpshat lhat shat

	set bpshat($src) [$src nb]
	set fpshat($src) [$src nf]

	# can't have loss in the encode path
	if { $src != "encoder" } {
		set p [$src np]
		set s [$src ns]
		set shat($src) $s
		set lhat($src) [expr $s-$p]
		if {$shat($src) <= 0.} {
			set loss 0
		} else {
			set loss [expr 100*$lhat($src)/$shat($src)]
		}
		if {$loss < .1} {
			set ltext($src) (0%)
		} elseif {$loss < 9.9} {
			set ltext($src) [format "(%.1f%%)" $loss]
		} else {
			set ltext($src) [format "(%.0f%%)" $loss]
		}
	}
	set fps $fpshat($src)
	set bps $bpshat($src)
	
	if { $fps < .1 } {
		set fps "0 f/s"
	} elseif { $fps < 10 } {
		set fps [format "%.1f f/s" $fps]
	} else {
		set fps [format "%2.0f f/s" $fps]
	}
	if { $bps < 1 } {
		set bps "0 bps"
	} elseif { $bps < 1000 } {
		set bps [format "%3.0f bps" $bps]
	} elseif { $bps < 1000000 } {
		set bps [format "%3.0f kb/s" [expr $bps / 1000]]
	} else {
		set bps [format "%.1f Mb/s" [expr $bps / 1000000]]
	}
	set ftext($src) $fps
	set btext($src) $bps
}

proc update_src { src } {
	global ftext
	if ![info exists ftext($src)] {
		return
	}
	update_rate $src
	after 1000 "update_src $src"
}

proc stat_select { w id } {
	$w.sc reset
	# XXX avoid core dumps in stripchart widget
	$w.sc configure -max 2 -min 1
	global maxStat
	catch "unset maxStat($w)"
}

proc whichstats { src } {
	return "[$src whichstats] [$src decoder-whichstats]"
}

proc mk.stats_panel { w src } {
	set f [smallfont]
	set p $w.f
	frame $p
	frame $p.name
	frame $p.diff
	frame $p.smooth
	frame $p.total
	set top [winfo toplevel $w]
	set gain [option get . statsFilter Vic]
	global rv_diff rv_smooth rv_list
	#
	# save list of stats because they might change and we want to
	# remember the rate variables that we have created
	#
	set names [whichstats $src]
	set rv_list($src) $names

	foreach name $names {
		set id [string tolower $name]
		radiobutton $p.name.$id -text $name -font $f -anchor w \
			-command "stat_select $top $id" \
			-variable statIndex($top) -value $id
		label $p.diff.$id -font $f -anchor e -width 9
		label $p.smooth.$id -font $f -anchor e -width 9
		label $p.total.$id -font $f -anchor e -width 9
		pack $p.name.$id -anchor w -fill x
		pack $p.smooth.$id $p.diff.$id $p.total.$id \
			-expand 1 -fill x -anchor e

		set rv_diff($src:$id) [$src counter $id]
		set rv_smooth($src:$id) [$src counter $id]

		rate_variable rv_diff($src:$id) 1.0 "%.1f"
		rate_variable rv_smooth($src:$id) $gain "%.1f"
	}
	#
	# Special case dvar since it's not a counter
	#
	radiobutton $p.name.dvar -text Delay-Variance -font $f -anchor w \
		-command "stat_select $top dvar" \
		-variable statIndex($top) -value dvar
	label $p.total.dvar -font $f -anchor e -width 9
	label $p.smooth.junk -font $f -anchor e -width 9
	label $p.diff.junk -font $f -anchor e -width 9
	pack $p.name.dvar -anchor w -fill x
	pack $p.smooth.junk $p.diff.junk $p.total.dvar \
		  -expand 1 -fill x -anchor e

	pack $p.name $p.smooth $p.diff $p.total -side left

	global statWindow statIndex maxStat
	set statWindow($top) $p
	set statIndex($top) [string tolower [lindex $names 0]]
	catch "unset maxStat($top)"

	pack $w.f -anchor c
}

proc stat_update_sc { w v } {
	global maxStat
	if ![info exists maxStat($w)] {
		set max [expr 2 * $v]
		if { $max <= 0 } { set max 1}
		set maxStat($w) $max
		$w.sc configure -max $v
	} elseif { $v > $maxStat($w) } {
		set maxStat($w) $v
		$w.sc configure -max $v
	}
	$w.sc set $v
}

proc stat_update { w src } {
	global statWindow statIndex maxStat rv_diff rv_smooth rv_list

	set names [whichstats $src]
	if { $names != $rv_list($src) } {
		pack forget $w.frame
		destroy $w.frame
		frame $w.frame -borderwidth 2 -relief groove
		mk.stats_panel $w.frame $src
		pack $w.frame -after $w.title -expand 1 -fill x -anchor center
	}
	
	$w.title.name configure -text [$src name]
	set fmt [$src format]
	if { $fmt == "" } { set fmt "?" }
	$w.title.info configure -text \
		"$fmt ([$src width]x[$src height]) [$src decoder-info]"
	set t [$src lastdata]
	if { $t == "" } { set t "never" }
	$w.title.timeData configure -text "last data heard $t"
	set t [$src lastctrl]
	if { $t == "" } { set t "never" }
	$w.title.timeCtrl configure -text "last control heard $t"

	set p $statWindow($w)
	set selected $statIndex($w)
	foreach id [whichstats $src] {
		set id [string tolower $id]
		set cntr [$src counter $id]
		set rv_diff($src:$id) $cntr
		set rv_smooth($src:$id) $cntr
		$p.total.$id configure -text $cntr
		$p.diff.$id configure -text $rv_diff($src:$id)
		$p.smooth.$id configure -text $rv_smooth($src:$id)
		if { $id == $selected } {
			stat_update_sc $w $rv_diff($src:$id)
		}
	}
	$p.total.dvar configure -text [$src dvar]
	if { $selected == "dvar" } {
		stat_update_sc $w [$src dvar]
	}
}

#
# Unset all the rate variables associated with the window,
# so that the C storage is freed up
#
proc stat_unset_rvs src {
	global rv_list rv_diff rv_smooth
	if [info exists rv_list($src)] {
		foreach name $rv_list($src) {
			set id [string tolower $name]
			unset rv_diff($src:$id)
			unset rv_smooth($src:$id)
		}
		unset rv_list($src)
	}
}

proc stat_destroy { w src } {
	stat_unset_rvs $src
	global stat_x stat_y
	set stat_x($src) [winfo rootx $w]
	set stat_y($src) [winfo rooty $w]
	destroy $w
}

#
# create a top-level window with summary statistics
# for the indicated source
#
proc src_summary { src } {
	global summary_window
	set summary_window ""
	set w .summary$src

	if [winfo exists $w] {
		stat_destroy $w $src
		return
	}

	toplevel $w
#	bind $w <Enter> "focus $w"
	global iconPrefix
	set name [$src name]
	wm iconname $w [option get . iconPrefix Vic]$name
	wm title $w $name
	wm transient $w .
	wm withdraw $w
	set f [smallfont]
	frame $w.title -borderwidth 2 -relief groove
	label $w.title.name -borderwidth 0 -font $f -anchor w
	label $w.title.info -borderwidth 0 -font $f -anchor w \
		-text [$src addr]
	label $w.title.timeData -borderwidth 0 -font $f -anchor w
	label $w.title.timeCtrl -borderwidth 0 -font $f -anchor w
	frame $w.frame -borderwidth 2 -relief groove

	mk.stats_panel $w.frame $src
	pack $w.title.name $w.title.info \
		$w.title.timeData $w.title.timeCtrl -fill x

	pack $w.title -fill x
	pack $w.frame -expand 1 -fill x -anchor center

	stripchart $w.sc -max 200 -min 1 -stripwidth 1 -width 1 \
		-relief groove -striprelief flat -tickcolor gray95 -hticks 30
	button $w.dismiss -borderwidth 2 -relief raised -font $f \
		-command "stat_destroy $w $src" -text Dismiss
	pack $w.sc -expand 1 -fill x
	pack $w.dismiss -anchor c -pady 4

	stat_update $w $src

	global stat_x stat_y
	if [info exists stat_x($src) ] {
		set x $stat_x($src)
		set y $stat_y($src)
	} else {
		global mouse_x mouse_y
		set x $mouse_x
		set y $mouse_y
		incr x [winfo rootx .]
		incr y [winfo rooty .]
		# adjust for virtual desktops
		incr x [winfo vrootx .]
		incr y [winfo vrooty .]
	}

	#
	# Need to do an update so that $w gets laid out allowing us to
	# look up its size.  This is tricky because of a possible race:
	# if the user releases the mouse, summary_window might get
	# destroyed during the update idletasks.  So we check
	# that the window still exists before proceeeding.
	#
#	if !$keep { set summary_window $w }
	update idletasks
	if ![winfo exists $w] { return }

	#
	# Check if window goes off the bottom or right.  Don't need
	# to check top or left since upper-left corner is at mouse.
	#
	set right [expr [winfo screenwidth .] - [winfo reqwidth $w] - 5]
	if { $x > $right } {
		set x $right
	}
	set bot [expr [winfo screenheight .] - [winfo reqheight $w] - 5]
	if { $y > $bot } {
		set y $bot
	}
	wm geometry $w +$x+$y
	wm deiconify $w
	global stat_timer_id
	if ![info exists stat_timer_id($w)] {
		set stat_timer_id($w) 0
	}
	incr stat_timer_id($w)
	after 1000 "stat_timer $w $src $stat_timer_id($w)"
}

proc stat_timer { w src id } {
	global stat_timer_id
	if { $id != $stat_timer_id($w) || ![winfo exists $w] } {
		return
	}
	stat_update $w $src
	after 1000 "stat_timer $w $src $id"
}

set helpno 0
proc helpitem { w text } {
	global helpno
	set f [option get . helpFont Vic]
	set h $w.h$helpno
	incr helpno
	frame $h
	canvas $h.bullet -width 12 -height 12 
	$h.bullet create oval 6 3 12 9 -fill black
	message $h.msg -justify left -anchor w -font $f -width 460 -text $text
	pack $h.bullet -side left -anchor ne -pady 5
	pack $h.msg -side left -expand 1 -fill x -anchor nw
	pack $h -expand 1 -fill both
}

proc build.help { } {
	set w .help
	if [winfo exists $w] { return }
	toplevel $w
#	bind $w <Enter> "focus $w"
	wm withdraw $w
	wm iconname $w "vic help"
	wm title $w "vic help"

	frame $w.frame -borderwidth 2 -relief raised
	set p $w.frame
	helpitem $p "Transmit video by clicking on the `Transmit' button \
in the menu popup.  You need video capture hardware to do this."
	helpitem $p "Incoming video streams appear in the main vic window.  \
If you see the message `No Network Sources', then no one is transmitting \
video to the conference address you're running on.  Otherwise, you'll \
see a thumbnail sized image and accompanying information for each source. \
Click on the thumbnail to open a larger view.  You can tile the thumbnails \
in multiple columns using the Tile... menu."
	helpitem $p "Clicking on the `mute' button for a given source will \
turn off decoding.  It is usually a good idea to do \
this for your own, looped-back transmission."
	helpitem $p "The transmission rate is controlled with the bit-rate \
and frame-rate sliders in the `Rate Control' section of the menu popup.  \
The more restrictive setting controls the transmission rate."
	helpitem $p "The video windows need not be fixed to a given source. \
The `Mode...' menu allows you to specify voice-switched and browse modes. \
In browse mode, the window automatically cycles through (unmuted) sources, \
while in voice-switched mode, the window switches to whoever is talking \
(using cues from vat).  You can have more than one voice-switched window, \
which results in simple LRU allocation of the windows to most recent \
speakers.  Consult the man page for details on voice-switched mode."
	helpitem $p "If the user interface looks peculiar, you might \
have X resources that conflict with tk.  A common problem is \
defining ``*background'' and/or ``*foreground''."
	helpitem $p "Bugs and suggestions to vic@ee.lbl.gov.  Thanks."

	button $w.frame.ok -text " Dismiss " -borderwidth 2 -relief raised \
		-command "wm withdraw $w" -font [mediumfont] 
	pack $w.frame.ok -pady 6 -padx 6 -anchor e

	pack $w.frame -expand 1 -fill both
}

proc vic_dialog { w text } {
	catch "destroy $w"
	toplevel $w -class Dialog
	wm title $w "vic error"
	wm iconname $w "vic error"

	label $w.label -text $text -font [mediumfont] -borderwidth 2 \
		-relief groove
	button $w.button -text Dismiss -command "destroy $w" -font [smallfont]
	pack $w.label -expand 1 -fill x -ipadx 4 -ipady 4
	pack $w.button -pady 4

	wm withdraw $w
	update idletasks
	set x [expr [winfo screenwidth $w]/2 - [winfo reqwidth $w]/2 \
		- [winfo vrootx [winfo parent $w]]]
	set y [expr [winfo screenheight $w]/2 - [winfo reqheight $w]/2 \
		- [winfo vrooty [winfo parent $w]]]
	wm geom $w +$x+$y
	wm deiconify $w

#	bind $w <Enter> "focus $w"
}

proc doupdate { } {
	global transmitButtonState
	if $transmitButtonState {
		update_rate encoder
	}
	update idletasks
	after 1000 doupdate
}
after 1000 doupdate

